#include        <stdio.h>
#include        <stdlib.h>

#define LOCATE(x,y)     fprintf(stderr, "\033[%d;%dH", (y)+1, (x)+1)
#define REVERSE()       fprintf(stderr, "\033[30;47m")
#define NORMAL()        fprintf(stderr, "\033[m")
#define COLOR(f,b)      fprintf(stderr, "\033[%d;%dm", (f), (b))
#define COLORB(f,b)     fprintf(stderr, "\033[1;%d;%dm", (f), (b))
#define CLS()           fprintf(stderr, "\033[2J")

#define VOFF            5



static char     *msg[] = {
                  /* ----+---10----+---20----+---30----+---40----+---50----+---60----+---70----+---80 */
                    "          MORPHY ONE                                                            ",
                    "                the world'd first open hardware palmtop pc!                     ",
                    "                                                                                ",
                    "                        CPU : AMD Elan SC400 (486 Compatible) 66MHZ             ",
                    "                     Memory : 32MB                                              ",
                    "                        LCD : 640x200 monochrome                                ",
                    "                        I/F : CF slot x2                                        ",
                    "                              CPLD                                              ",
                    "                      Power : SUM3 x2, CR2032                                   ",
                    "                       Size : W146xD80xH22 (mm)                                 ",
                    "                     Weight : 275g                                              ",
                    "                                                                                ",
                    "                                                                                ",
                    "          coming soon...                                                        ",
                };



static int      KurosawaRandom( void )
{
        static unsigned short lastRnd = 0;

        lastRnd ^= 0x9630;      /* magic #1, 9630 = NT */
        lastRnd -= 0x6553;      /* magic #2 */
        lastRnd = (lastRnd<< 2) /* magic #3 */
                 |(lastRnd>>14);/* [eCgZq~cȁH */
        return (signed short)lastRnd;
}



static void     delay( void )
{
        int             i, j;
        for ( i = 0; i < 6; ++i ) {
            for ( j = 0; j < 32766; ++j ) {
                j = j;
            }
        }
}



void            putH( void )
{
        int             l, c;
        char            *p;

        for ( c = 0; c < 80; ++c ) {
            for ( l = 0; l < sizeof(msg)/sizeof(char *); ++l ) {
                p = msg[l];
                switch ( l&1 ) {
                case 0:
                    LOCATE(c, l+VOFF);
                    putchar(*(p+c));
                    break;
                case 1:
                    LOCATE(79-c, l+VOFF);
                    putchar(*(p+79-c));
                }
                LOCATE(0,24);
                delay();
            }
        }
}



void            clrH( void )
{
        int             l, c;

        for ( c = 0; c < 80; ++c ) {
            for ( l = 0; l < sizeof(msg)/sizeof(char *); ++l ) {
                switch ( l&1 ) {
                case 0:
                    LOCATE(c, l+VOFF);
                    putchar(' ');
                    break;
                case 1:
                    LOCATE(79-c, l+VOFF);
                    putchar(' ');
                }
                LOCATE(0,24);
                delay();
            }
        }
}



void            putV( void )
{
        int             l, c;
        char            *p;

        for ( l = 0; l < sizeof(msg)/sizeof(char *); ++l ) {
            for ( c = 0; c < 80; ++c ) {
                switch ( c&1 ) {
                case 0:
                    p = msg[l];
                    LOCATE(c, l+VOFF);
                    putchar(*(p+c));
                    break;
                case 1:
                    p = msg[(sizeof(msg)/sizeof(char *))-1-l];
                    LOCATE(c, (sizeof(msg)/sizeof(char *))-1-l+VOFF);
                    putchar(*(p+c));
                }
                LOCATE(0,24);
                delay();
            }
        }
}



void            clrV( void )
{
        int             l, c;

        for ( l = 0; l < sizeof(msg)/sizeof(char *); ++l ) {
            for ( c = 0; c < 80; ++c ) {
                switch ( c&1 ) {
                case 0:
                    LOCATE(c, l+VOFF);
                    putchar(' ');
                    break;
                case 1:
                    LOCATE(c, (sizeof(msg)/sizeof(char *))-1-l+VOFF);
                    putchar(' ');
                }
                LOCATE(0,24);
                delay();
            }
        }
}



void            putR( void )
{
        int             l, c, i, j;
        char            *p;

        for ( i = 0; i < 300; ++i ) {
            for ( j = 0; j < 4; ++j ) {
                l = (unsigned)KurosawaRandom()%(sizeof(msg)/sizeof(char *));
                p = msg[l];
                c = (unsigned)KurosawaRandom()%80;
                LOCATE(c, l+VOFF);
                putchar(*(p+c));
            }
            LOCATE(0,24);
            delay();
        }
        for ( l = 0; l < sizeof(msg)/sizeof(char *); ++l ) {
            p = msg[l];
            LOCATE(0, l+VOFF);
            puts(p);
        }
}



void            clrR( void )
{
        int             l, c, i, j;

        for ( i = 0; i < 300; ++i ) {
            for ( j = 0; j < 4; ++j ) {
                l = (unsigned)KurosawaRandom()%(sizeof(msg)/sizeof(char *));
                c = (unsigned)KurosawaRandom()%80;
                LOCATE(c, l+VOFF);
                putchar(' ');
            }
            LOCATE(0,24);
            delay();
        }
        for ( l = 0; l < sizeof(msg)/sizeof(char *); ++l ) {
            LOCATE(0, l+VOFF);
               /* ----+---10----+---20----+---30----+---40----+---50----+---60----+---70----+---80 */
            puts("                                                                                ");
        }
}



int             main(
                    int             argc,
                    char            *argv[]
                )
{
        int             i;

        CLS();

        for ( ; ; ) {
            putH();
            for ( i = 0; i < 20; ++i ) {
                delay();
                if ( kbhit() ) {
                    goto ALLDONE;
                }
            }
            clrH();
            for ( i = 0; i < 5; ++i ) {
                delay();
                if ( kbhit() ) {
                    goto ALLDONE;
                }
            }
            putV();
            for ( i = 0; i < 20; ++i ) {
                delay();
                if ( kbhit() ) {
                    goto ALLDONE;
                }
            }
            clrV();
            for ( i = 0; i < 5; ++i ) {
                delay();
                if ( kbhit() ) {
                    goto ALLDONE;
                }
            }
            putR();
            for ( i = 0; i < 20; ++i ) {
                delay();
                if ( kbhit() ) {
                    goto ALLDONE;
                }
            }
            clrR();
            for ( i = 0; i < 5; ++i ) {
                delay();
                if ( kbhit() ) {
                    goto ALLDONE;
                }
            }
        }

ALLDONE:;

        return EXIT_SUCCESS;
}
